using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.CMSHelper;
using CMS.Ecommerce;
using CMS.EcommerceProvider;
using CMS.GlobalHelper;
using CMS.DataEngine;


public partial class CMSModules_Ecommerce_Controls_PayPalStep : ShoppingCartStep
{

    protected void Page_Load(object sender, EventArgs e)
    {
        // Get productId from URL
        int skuId = ValidationHelper.GetInteger(Request.QueryString["productId"], 0);

        // Get product units from URL
        int units = ValidationHelper.GetInteger(Request.QueryString["quantity"], 0);

        // Get product options from URL
        string [] options = ValidationHelper.GetString(Request.QueryString["options"], "").Split(',');                



        // Add product and product options to shopping cart
        this.ShoppingCartInfoObj.AddShoppingCartItem(skuId, units, GetIntOptions(options));
        
        string paypal = "paypal"; // Here comes your paypal payment method code name

        // Get paypal payment method details
        PaymentOptionInfo payment = PaymentOptionInfoProvider.GetPaymentOptionInfo(paypal, CMSContext.CurrentSiteName);
        if (payment != null)
        {
            // Set PayPal payment method ID to shopping cart object
            this.ShoppingCartInfoObj.ShoppingCartPaymentOptionID = payment.PaymentOptionID;

            // Process payment by PayPal provider
            this.ShoppingCartControl.PaymentGatewayProvider.ProcessPayment();
        }        
    }



    /// <summary>
    /// Transforms an array of string values to array of integer values.
    /// </summary>
    /// <param name="options">Array with string values.</param>
    /// <returns></returns>
    private int[] GetIntOptions(string[] options)
    {
        if (options != null)
        {
            // Get product options as integer values
            int[] intOptions = new int[options.Length];
            for (int i = 0; i < options.Length; i++)
            {
                intOptions[i] = ValidationHelper.GetInteger(options[i], 0);
            }
            return intOptions;
        }
        return null;
    }
}
